/*
 * Copyright (c) 2015-2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef __ATLAS7_IOC_H__
#define __ATLAS7_IOC_H__

#include <io.h>
#include <pm.h>

/* Registers of IOC RTC */
#define _IOC_RTC_REG_BASE 0x18880000

#define A7DA_IOCRTC_FUNC_SEL_0_REG_SET		(_IOC_RTC_REG_BASE + 0x0000)
#define A7DA_IOCRTC_FUNC_SEL_0_REG_CLR		(_IOC_RTC_REG_BASE + 0x0004)
#define A7DA_IOCRTC_FUNC_SEL_1_REG_SET		(_IOC_RTC_REG_BASE + 0x0008)
#define A7DA_IOCRTC_FUNC_SEL_1_REG_CLR		(_IOC_RTC_REG_BASE + 0x000C)
#define A7DA_IOCRTC_FUNC_SEL_2_REG_SET		(_IOC_RTC_REG_BASE + 0x0010)
#define A7DA_IOCRTC_FUNC_SEL_2_REG_CLR		(_IOC_RTC_REG_BASE + 0x0014)
#define A7DA_IOCRTC_PULL_EN_0_REG_SET		(_IOC_RTC_REG_BASE + 0x0100)
#define A7DA_IOCRTC_PULL_EN_0_REG_CLR		(_IOC_RTC_REG_BASE + 0x0104)
#define A7DA_IOCRTC_PULL_EN_1_REG_SET		(_IOC_RTC_REG_BASE + 0x0108)
#define A7DA_IOCRTC_PULL_EN_1_REG_CLR		(_IOC_RTC_REG_BASE + 0x010C)
#define A7DA_IOCRTC_STRENGTH_CNTL_0_REG_SET	(_IOC_RTC_REG_BASE + 0x0200)
#define A7DA_IOCRTC_STRENGTH_CNTL_0_REG_CLR	(_IOC_RTC_REG_BASE + 0x0204)
#define A7DA_IOCRTC_STRENGTH_CNTL_1_REG_SET	(_IOC_RTC_REG_BASE + 0x0208)
#define A7DA_IOCRTC_STRENGTH_CNTL_1_REG_CLR	(_IOC_RTC_REG_BASE + 0x020C)
#define A7DA_IOCRTC_IN_DISABLE_0_REG_SET	(_IOC_RTC_REG_BASE + 0x0A00)
#define A7DA_IOCRTC_IN_DISABLE_0_REG_CLR	(_IOC_RTC_REG_BASE + 0x0A04)
#define A7DA_IOCRTC_IN_DISABLE_1_REG_SET	(_IOC_RTC_REG_BASE + 0x0A08)
#define A7DA_IOCRTC_IN_DISABLE_1_REG_CLR	(_IOC_RTC_REG_BASE + 0x0A0C)
#define A7DA_IOCRTC_IN_DISABLE_2_REG_SET	(_IOC_RTC_REG_BASE + 0x0A10)
#define A7DA_IOCRTC_IN_DISABLE_2_REG_CLR	(_IOC_RTC_REG_BASE + 0x0A14)
#define A7DA_IOCRTC_IN_DISABLE_VAL_0_REG_SET	(_IOC_RTC_REG_BASE + 0x0A80)
#define A7DA_IOCRTC_IN_DISABLE_VAL_0_REG_CLR	(_IOC_RTC_REG_BASE + 0x0A84)
#define A7DA_IOCRTC_IN_DISABLE_VAL_1_REG_SET	(_IOC_RTC_REG_BASE + 0x0A88)
#define A7DA_IOCRTC_IN_DISABLE_VAL_1_REG_CLR	(_IOC_RTC_REG_BASE + 0x0A8C)

/* Registers of IOC TOP */
#define _IOC_TOP_REG_BASE 0x10E40000

#define A7DA_IOCTOP_FUNC_SEL_0_REG_SET		(_IOC_TOP_REG_BASE + 0x0080)
#define A7DA_IOCTOP_FUNC_SEL_0_REG_CLR		(_IOC_TOP_REG_BASE + 0x0084)
#define A7DA_IOCTOP_FUNC_SEL_1_REG_SET		(_IOC_TOP_REG_BASE + 0x0088)
#define A7DA_IOCTOP_FUNC_SEL_1_REG_CLR		(_IOC_TOP_REG_BASE + 0x008C)
#define A7DA_IOCTOP_FUNC_SEL_2_REG_SET		(_IOC_TOP_REG_BASE + 0x0090)
#define A7DA_IOCTOP_FUNC_SEL_2_REG_CLR		(_IOC_TOP_REG_BASE + 0x0094)
#define A7DA_IOCTOP_FUNC_SEL_3_REG_SET		(_IOC_TOP_REG_BASE + 0x0098)
#define A7DA_IOCTOP_FUNC_SEL_3_REG_CLR		(_IOC_TOP_REG_BASE + 0x009C)
#define A7DA_IOCTOP_FUNC_SEL_4_REG_SET		(_IOC_TOP_REG_BASE + 0x00A0)
#define A7DA_IOCTOP_FUNC_SEL_4_REG_CLR		(_IOC_TOP_REG_BASE + 0x00A4)
#define A7DA_IOCTOP_FUNC_SEL_5_REG_SET		(_IOC_TOP_REG_BASE + 0x00A8)
#define A7DA_IOCTOP_FUNC_SEL_5_REG_CLR		(_IOC_TOP_REG_BASE + 0x00AC)
#define A7DA_IOCTOP_FUNC_SEL_6_REG_SET		(_IOC_TOP_REG_BASE + 0x00B0)
#define A7DA_IOCTOP_FUNC_SEL_6_REG_CLR		(_IOC_TOP_REG_BASE + 0x00B4)
#define A7DA_IOCTOP_FUNC_SEL_7_REG_SET		(_IOC_TOP_REG_BASE + 0x00B8)
#define A7DA_IOCTOP_FUNC_SEL_7_REG_CLR		(_IOC_TOP_REG_BASE + 0x00BC)
#define A7DA_IOCTOP_FUNC_SEL_8_REG_SET		(_IOC_TOP_REG_BASE + 0x00C0)
#define A7DA_IOCTOP_FUNC_SEL_8_REG_CLR		(_IOC_TOP_REG_BASE + 0x00C4)
#define A7DA_IOCTOP_FUNC_SEL_9_REG_SET		(_IOC_TOP_REG_BASE + 0x00C8)
#define A7DA_IOCTOP_FUNC_SEL_9_REG_CLR		(_IOC_TOP_REG_BASE + 0x00CC)
#define A7DA_IOCTOP_FUNC_SEL_10_REG_SET		(_IOC_TOP_REG_BASE + 0x00D0)
#define A7DA_IOCTOP_FUNC_SEL_10_REG_CLR		(_IOC_TOP_REG_BASE + 0x00D4)
#define A7DA_IOCTOP_FUNC_SEL_11_REG_SET		(_IOC_TOP_REG_BASE + 0x00D8)
#define A7DA_IOCTOP_FUNC_SEL_11_REG_CLR		(_IOC_TOP_REG_BASE + 0x00DC)
#define A7DA_IOCTOP_FUNC_SEL_12_REG_SET		(_IOC_TOP_REG_BASE + 0x00E0)
#define A7DA_IOCTOP_FUNC_SEL_12_REG_CLR		(_IOC_TOP_REG_BASE + 0x00E4)
#define A7DA_IOCTOP_FUNC_SEL_13_REG_SET		(_IOC_TOP_REG_BASE + 0x00E8)
#define A7DA_IOCTOP_FUNC_SEL_13_REG_CLR		(_IOC_TOP_REG_BASE + 0x00EC)
#define A7DA_IOCTOP_FUNC_SEL_14_REG_SET		(_IOC_TOP_REG_BASE + 0x00F0)
#define A7DA_IOCTOP_FUNC_SEL_14_REG_CLR		(_IOC_TOP_REG_BASE + 0x00F4)
#define A7DA_IOCTOP_FUNC_SEL_15_REG_SET		(_IOC_TOP_REG_BASE + 0x00F8)
#define A7DA_IOCTOP_FUNC_SEL_15_REG_CLR		(_IOC_TOP_REG_BASE + 0x00FC)
#define A7DA_IOCTOP_FUNC_SEL_16_REG_SET		(_IOC_TOP_REG_BASE + 0x0100)
#define A7DA_IOCTOP_FUNC_SEL_16_REG_CLR		(_IOC_TOP_REG_BASE + 0x0104)
#define A7DA_IOCTOP_FUNC_SEL_17_REG_SET		(_IOC_TOP_REG_BASE + 0x0108)
#define A7DA_IOCTOP_FUNC_SEL_17_REG_CLR		(_IOC_TOP_REG_BASE + 0x010C)
#define A7DA_IOCTOP_FUNC_SEL_18_REG_SET		(_IOC_TOP_REG_BASE + 0x0110)
#define A7DA_IOCTOP_FUNC_SEL_18_REG_CLR		(_IOC_TOP_REG_BASE + 0x0114)
#define A7DA_IOCTOP_FUNC_SEL_19_REG_SET		(_IOC_TOP_REG_BASE + 0x0118)
#define A7DA_IOCTOP_FUNC_SEL_19_REG_CLR		(_IOC_TOP_REG_BASE + 0x011C)
#define A7DA_IOCTOP_FUNC_SEL_20_REG_SET		(_IOC_TOP_REG_BASE + 0x0120)
#define A7DA_IOCTOP_FUNC_SEL_20_REG_CLR		(_IOC_TOP_REG_BASE + 0x0124)
#define A7DA_IOCTOP_FUNC_SEL_21_REG_SET		(_IOC_TOP_REG_BASE + 0x0128)
#define A7DA_IOCTOP_FUNC_SEL_21_REG_CLR		(_IOC_TOP_REG_BASE + 0x012C)
#define A7DA_IOCTOP_FUNC_SEL_22_REG_SET		(_IOC_TOP_REG_BASE + 0x0130)
#define A7DA_IOCTOP_FUNC_SEL_22_REG_CLR		(_IOC_TOP_REG_BASE + 0x0134)
#define A7DA_IOCTOP_FUNC_SEL_23_REG_SET		(_IOC_TOP_REG_BASE + 0x0138)
#define A7DA_IOCTOP_FUNC_SEL_23_REG_CLR		(_IOC_TOP_REG_BASE + 0x013C)
#define A7DA_IOCTOP_PULL_EN_0_REG_SET		(_IOC_TOP_REG_BASE + 0x0180)
#define A7DA_IOCTOP_PULL_EN_0_REG_CLR		(_IOC_TOP_REG_BASE + 0x0184)
#define A7DA_IOCTOP_PULL_EN_1_REG_SET		(_IOC_TOP_REG_BASE + 0x0188)
#define A7DA_IOCTOP_PULL_EN_1_REG_CLR		(_IOC_TOP_REG_BASE + 0x018C)
#define A7DA_IOCTOP_PULL_EN_2_REG_SET		(_IOC_TOP_REG_BASE + 0x0190)
#define A7DA_IOCTOP_PULL_EN_2_REG_CLR		(_IOC_TOP_REG_BASE + 0x0194)
#define A7DA_IOCTOP_PULL_EN_3_REG_SET		(_IOC_TOP_REG_BASE + 0x0198)
#define A7DA_IOCTOP_PULL_EN_3_REG_CLR		(_IOC_TOP_REG_BASE + 0x019C)
#define A7DA_IOCTOP_PULL_EN_4_REG_SET		(_IOC_TOP_REG_BASE + 0x01A0)
#define A7DA_IOCTOP_PULL_EN_4_REG_CLR		(_IOC_TOP_REG_BASE + 0x01A4)
#define A7DA_IOCTOP_PULL_EN_5_REG_SET		(_IOC_TOP_REG_BASE + 0x01A8)
#define A7DA_IOCTOP_PULL_EN_5_REG_CLR		(_IOC_TOP_REG_BASE + 0x01AC)
#define A7DA_IOCTOP_PULL_EN_6_REG_SET		(_IOC_TOP_REG_BASE + 0x01B0)
#define A7DA_IOCTOP_PULL_EN_6_REG_CLR		(_IOC_TOP_REG_BASE + 0x01B4)
#define A7DA_IOCTOP_PULL_EN_7_REG_SET		(_IOC_TOP_REG_BASE + 0x01B8)
#define A7DA_IOCTOP_PULL_EN_7_REG_CLR		(_IOC_TOP_REG_BASE + 0x01BC)
#define A7DA_IOCTOP_PULL_EN_8_REG_SET		(_IOC_TOP_REG_BASE + 0x01C0)
#define A7DA_IOCTOP_PULL_EN_8_REG_CLR		(_IOC_TOP_REG_BASE + 0x01C4)
#define A7DA_IOCTOP_PULL_EN_9_REG_SET		(_IOC_TOP_REG_BASE + 0x01C8)
#define A7DA_IOCTOP_PULL_EN_9_REG_CLR		(_IOC_TOP_REG_BASE + 0x01CC)
#define A7DA_IOCTOP_PULL_EN_10_REG_SET		(_IOC_TOP_REG_BASE + 0x0200)
#define A7DA_IOCTOP_PULL_EN_10_REG_CLR		(_IOC_TOP_REG_BASE + 0x0204)
#define A7DA_IOCTOP_PULL_EN_11_REG_SET		(_IOC_TOP_REG_BASE + 0x0250)
#define A7DA_IOCTOP_PULL_EN_11_REG_CLR		(_IOC_TOP_REG_BASE + 0x0254)
#define A7DA_IOCTOP_PULL_EN_12_REG_SET		(_IOC_TOP_REG_BASE + 0x0258)
#define A7DA_IOCTOP_PULL_EN_12_REG_CLR		(_IOC_TOP_REG_BASE + 0x025C)
#define A7DA_IOCTOP_PULL_EN_13_REG_SET		(_IOC_TOP_REG_BASE + 0x0260)
#define A7DA_IOCTOP_PULL_EN_13_REG_CLR		(_IOC_TOP_REG_BASE + 0x0264)
#define A7DA_IOCTOP_PULL_EN_14_REG_SET		(_IOC_TOP_REG_BASE + 0x0268)
#define A7DA_IOCTOP_PULL_EN_14_REG_CLR		(_IOC_TOP_REG_BASE + 0x026C)
#define A7DA_IOCTOP_PULL_EN_15_REG_SET		(_IOC_TOP_REG_BASE + 0x0270)
#define A7DA_IOCTOP_PULL_EN_15_REG_CLR		(_IOC_TOP_REG_BASE + 0x0274)
#define A7DA_IOCTOP_PULL_EN_16_REG_SET		(_IOC_TOP_REG_BASE + 0x0278)
#define A7DA_IOCTOP_PULL_EN_16_REG_CLR		(_IOC_TOP_REG_BASE + 0x027C)
#define A7DA_IOCTOP_STRENGTH_CNTL_0_REG_SET	(_IOC_TOP_REG_BASE + 0x0300)
#define A7DA_IOCTOP_STRENGTH_CNTL_0_REG_CLR	(_IOC_TOP_REG_BASE + 0x0304)
#define A7DA_IOCTOP_STRENGTH_CNTL_1_REG_SET	(_IOC_TOP_REG_BASE + 0x0308)
#define A7DA_IOCTOP_STRENGTH_CNTL_1_REG_CLR	(_IOC_TOP_REG_BASE + 0x030C)
#define A7DA_IOCTOP_STRENGTH_CNTL_2_REG_SET	(_IOC_TOP_REG_BASE + 0x0310)
#define A7DA_IOCTOP_STRENGTH_CNTL_2_REG_CLR	(_IOC_TOP_REG_BASE + 0x0314)
#define A7DA_IOCTOP_STRENGTH_CNTL_3_REG_SET	(_IOC_TOP_REG_BASE + 0x0318)
#define A7DA_IOCTOP_STRENGTH_CNTL_3_REG_CLR	(_IOC_TOP_REG_BASE + 0x031C)
#define A7DA_IOCTOP_STRENGTH_CNTL_4_REG_SET	(_IOC_TOP_REG_BASE + 0x0320)
#define A7DA_IOCTOP_STRENGTH_CNTL_4_REG_CLR	(_IOC_TOP_REG_BASE + 0x0324)
#define A7DA_IOCTOP_STRENGTH_CNTL_5_REG_SET	(_IOC_TOP_REG_BASE + 0x0328)
#define A7DA_IOCTOP_STRENGTH_CNTL_5_REG_CLR	(_IOC_TOP_REG_BASE + 0x032C)
#define A7DA_IOCTOP_STRENGTH_CNTL_6_REG_SET	(_IOC_TOP_REG_BASE + 0x0330)
#define A7DA_IOCTOP_STRENGTH_CNTL_6_REG_CLR	(_IOC_TOP_REG_BASE + 0x0334)
#define A7DA_IOCTOP_STRENGTH_CNTL_7_REG_SET	(_IOC_TOP_REG_BASE + 0x0338)
#define A7DA_IOCTOP_STRENGTH_CNTL_7_REG_CLR	(_IOC_TOP_REG_BASE + 0x033C)
#define A7DA_IOCTOP_STRENGTH_CNTL_8_REG_SET	(_IOC_TOP_REG_BASE + 0x0340)
#define A7DA_IOCTOP_STRENGTH_CNTL_8_REG_CLR	(_IOC_TOP_REG_BASE + 0x0344)
#define A7DA_IOCTOP_STRENGTH_CNTL_9_REG_SET	(_IOC_TOP_REG_BASE + 0x0348)
#define A7DA_IOCTOP_STRENGTH_CNTL_9_REG_CLR	(_IOC_TOP_REG_BASE + 0x034C)
#define A7DA_IOCTOP_STRENGTH_CNTL_10_REG_SET	(_IOC_TOP_REG_BASE + 0x0350)
#define A7DA_IOCTOP_STRENGTH_CNTL_10_REG_CLR	(_IOC_TOP_REG_BASE + 0x0354)
#define A7DA_IOCTOP_STRENGTH_CNTL_11_REG_SET	(_IOC_TOP_REG_BASE + 0x0358)
#define A7DA_IOCTOP_STRENGTH_CNTL_11_REG_CLR	(_IOC_TOP_REG_BASE + 0x035C)
#define A7DA_IOCTOP_STRENGTH_CNTL_12_REG_SET	(_IOC_TOP_REG_BASE + 0x0360)
#define A7DA_IOCTOP_STRENGTH_CNTL_12_REG_CLR	(_IOC_TOP_REG_BASE + 0x0364)
#define A7DA_IOCTOP_STRENGTH_CNTL_13_REG_SET	(_IOC_TOP_REG_BASE + 0x0368)
#define A7DA_IOCTOP_STRENGTH_CNTL_13_REG_CLR	(_IOC_TOP_REG_BASE + 0x036C)
#define A7DA_IOCTOP_STRENGTH_CNTL_14_REG_SET	(_IOC_TOP_REG_BASE + 0x0378)
#define A7DA_IOCTOP_STRENGTH_CNTL_14_REG_CLR	(_IOC_TOP_REG_BASE + 0x037C)
#define A7DA_IOCTOP_AD_CNTL_0_REG_SET		(_IOC_TOP_REG_BASE + 0x0480)
#define A7DA_IOCTOP_AD_CNTL_0_REG_CLR		(_IOC_TOP_REG_BASE + 0x0484)

/* RTC GPIO */
#define A7DA_GPIO_RTCM_CFG_4			0x18890010
#define A7DA_GPIO_RTCM_CFG_8			0x18890020

/* The mux function mask */
#define FUNC_MASK 0x7

/* enable atlas7 uart0 pin mux */
static inline void ioc_enable_uart_mux(void)
{
	SOC_REG(A7DA_IOCTOP_FUNC_SEL_19_REG_CLR) =
				SHIFT_L(FUNC_MASK, 0) | SHIFT_L(FUNC_MASK, 4);
	SOC_REG(A7DA_IOCTOP_FUNC_SEL_19_REG_SET) = BIT0 | BIT4;
}

/* enable atlas7 qspi pin mux */
static inline void ioc_enable_qspi_mux(void)
{
	/*
	 * config PIN share
	 * because IOC_RTC will not be reset, so resetting their values
	 * pull up/down
	 */
	SOC_REG(A7DA_IOCRTC_PULL_EN_0_REG_SET) = (BIT24 | BIT26 | BIT28 | BIT30);
	SOC_REG(A7DA_IOCRTC_PULL_EN_1_REG_SET) = (BIT0 | BIT2);

	/*Drive strength low strength */
	SOC_REG(A7DA_IOCRTC_STRENGTH_CNTL_0_REG_CLR) =
					(BIT24 | BIT26 | BIT28 | BIT30);
	SOC_REG(A7DA_IOCRTC_STRENGTH_CNTL_1_REG_CLR) = (BIT0 | BIT2);

	/*Function select*/
	SOC_REG(A7DA_IOCRTC_FUNC_SEL_1_REG_CLR) =
			SHIFT_L(FUNC_MASK, 16) | SHIFT_L(FUNC_MASK, 20) |
			SHIFT_L(FUNC_MASK, 24) | SHIFT_L(FUNC_MASK, 28);
	SOC_REG(A7DA_IOCRTC_FUNC_SEL_1_REG_SET) =
				(BIT16 | BIT20 | BIT24 | BIT28);

	SOC_REG(A7DA_IOCRTC_FUNC_SEL_2_REG_CLR) =
			SHIFT_L(FUNC_MASK, 0) | SHIFT_L(FUNC_MASK, 4);
	SOC_REG(A7DA_IOCRTC_FUNC_SEL_2_REG_SET) = (BIT0 | BIT4);
}

/* enable atlas7 can bus 0 mux */
static inline void ioc_enable_can0_mux(void)
{
#if 0
	SOC_REG(A7DA_IOCRTC_PULL_EN_0_REG_SET) = (BIT20 | BIT22);
	SOC_REG(A7DA_IOCRTC_STRENGTH_CNTL_0_REG_SET) = (BIT20 | BIT22);
#endif
	SOC_REG(A7DA_IOCRTC_FUNC_SEL_0_REG_CLR) = 0x7 << 4;

	SOC_REG(A7DA_IOCRTC_FUNC_SEL_0_REG_SET) = 0x2 << 4;

	/*Function select*/
	SOC_REG(A7DA_IOCRTC_FUNC_SEL_1_REG_CLR) =
			SHIFT_L(FUNC_MASK, 8) | SHIFT_L(FUNC_MASK, 12);
	SOC_REG(A7DA_IOCRTC_FUNC_SEL_1_REG_SET) = (BIT8 | BIT12);

	SOC_REG(A7DA_IOCRTC_IN_DISABLE_1_REG_CLR) = BIT9;
}

/* enable atlas7 can bus 0 transceiver mux */
static inline void ioc_enable_can_transceiver_mux(void)
{
	if(FALSE==ENABLE_M3_CAN1_WAKUP())
	{
		/* enable GPIO function */
		SOC_REG(A7DA_IOCRTC_FUNC_SEL_0_REG_CLR) =
				SHIFT_L(FUNC_MASK, 0) | SHIFT_L(FUNC_MASK, 8);	/* RTC_GPIO_0 and RTC_GPIO_2 */
	}
	else
	{
		SOC_REG(A7DA_IOCRTC_FUNC_SEL_0_REG_CLR) =
					SHIFT_L(FUNC_MASK, 0);	/* RTC_GPIO_0 */
	}
}

/* enable atlas7 can bus 1 mux */
static inline __on_retain void ioc_enable_can1_mux(void)
{
	if(FALSE==ENABLE_M3_CAN1_WAKUP())
	{
		/* set uart3_tx & uart3_rx */
		SOC_REG(A7DA_IOCTOP_FUNC_SEL_19_REG_CLR) =
				SHIFT_L(FUNC_MASK, 24) | SHIFT_L(FUNC_MASK, 28);
		SOC_REG(A7DA_IOCTOP_FUNC_SEL_19_REG_SET) =
				SHIFT_L(0x2, 24) | SHIFT_L(0x2, 28);
		SOC_REG(A7DA_IOCRTC_IN_DISABLE_0_REG_CLR) = BIT4;
	}
	else
	{
		/*	use rtc_gpio2 as rx and rtc_gpio3 as tx */
		SOC_REG(A7DA_IOCRTC_FUNC_SEL_0_REG_CLR) =
				SHIFT_L(FUNC_MASK, 8) | SHIFT_L(FUNC_MASK, 12);

		SOC_REG(A7DA_IOCRTC_FUNC_SEL_0_REG_SET) =
				SHIFT_L(0x2, 8) | SHIFT_L(0x2, 12);
		SOC_REG(A7DA_IOCRTC_IN_DISABLE_0_REG_CLR) = BIT4;
		SOC_REG(A7DA_IOCRTC_IN_DISABLE_2_REG_SET) = BIT9;
	}
}

#endif /* __ATLAS7_IOC_H__ */
